/*
    HistoryWindow

	Copyright (c) 2009 by Alexander Kazarin <boiler@co.ru>

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************
*/

#ifndef HISTORYWINDOW_H
#define HISTORYWINDOW_H

#include <QtGui/QWidget>
#include <QByteArray>
#include <qutim/plugininterface.h>
#include "ui_formhist.h"
#include <QSqlDatabase>
#include <QSqlQuery>
#include <QtSql>
#include <QSqlQueryModel>
#include <QTableView>
#include "customsqlmodel.h"

using namespace qutim_sdk_0_2;

namespace SqlHistoryNamespace {

class SqlEngine;

class HistoryWindow : public QWidget
{
    Q_OBJECT

public:
	HistoryWindow(const TreeModelItem &item, SqlEngine *engine, QWidget *parent = 0);

private slots:
    //void on_searchButton_clicked();
    void on_historyView_doubleClicked(QModelIndex index);
    void on_toolButton_4_clicked();
    void on_toolButton_3_clicked();
    void on_toolButton_2_clicked();
    void on_toolButton_clicked();
    void on_historyView_activated(QModelIndex index);
    void on_historyView_clicked(QModelIndex index);
    void on_searchEdit_editingFinished();
    void on_searchEdit_textChanged(QString );
    void on_dateEdit_to_dateChanged(QDate date);
    void on_dateEdit_from_dateChanged(QDate date);
    void on_checkBox_to_stateChanged(int );
    void on_checkBox_from_stateChanged(int );
    void fillContactComboBox(int index);
    void searchChanged();
    void updateSelection(const QItemSelection &selected,
         const QItemSelection &deselected);
    
private:
	void fillAccountComboBox();
        void fillDirectionComboBox();
        void changePrev(QModelIndex index);
	void setIcons();
        void initTmpTables();
        void initTmpTablesCnt(int index);
        Ui::XHistoryWindowClass ui;
	qutim_sdk_0_3::TreeModelItem m_item;
        QString m_history_path;
	QString m_search_word;
        QString m_collate;
	SqlEngine *m_engine;
	QList<QTreeWidgetItem*> selectedItems;
        CustomSqlModel model;
};

}

#endif // HISTORYWINDOW_H
